SystemOrganization addCategory: #'TP-TADP-METAP-TEST'!
SystemOrganization addCategory: #'Tp-TADP'!
SystemOrganization addCategory: #'Tp-TADP-META2'!
SystemOrganization addCategory: #'Tp-TADP-META4'!
SystemOrganization addCategory: #'Tp-TADP-METAP-TEST'!
SystemOrganization addCategory: #'Tp-TADP-Mascotas'!
SystemOrganization addCategory: #'Tp-TADP-Meta1'!
SystemOrganization addCategory: #'Tp-TADP-Test'!

Trait named: #ConPosicion
	uses: {}
	category: 'Tp-TADP'!

!ConPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:34'!
coincide: unElemento con: otroElemento
	unElemento = otroElemento ifTrue: [^1]. ^0! !

!ConPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:28'!
cuantosAciertosTiene: unaJugada
	^ self  posiciones inject: 0 into: [:acum :unaPosicion | acum + (self coincide: (unaJugada at: unaPosicion) con: (self ultimaJugadaGanadora at: unaPosicion))] ! !

Trait named: #Poceado
	uses: {}
	category: 'Tp-TADP'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 15:28'!
PorcentajeParaAgencia
"
4-
Es medio raro definir que todos los juegos poceados por default le pagan 5% a la agencia. Me suena ms razonable que cada juego lo defina (requirement).
De paso, el nombre no dice que en realidad es solo el porcentaje sobre las apuestas ganadoras solamente, no por vender una apuesta cualquiera.
"
	^ 0.05! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 15:49'!
actualizarPozo
"
2-
No necesito actualizar el pozo si para m el pozo ES la suma de valores de jugadas.

4-
Los juegos poceados no soportan que las jugadas puedan tener diferentes valores. Tal vez si agrego un juego poceado en el futuro lo quiera (igual es discutible porque es sobredisear un poco).
"
	self pozo:  (self apuestasEnJuego size * self valorDeJugada)! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 15:39'!
calculaAciertos: numeroDeAciertos paraJugada: jugadaGanadora
"
4-
Esta parte tambin se puede resolver con un mapa con cantidad de aciertos como clave y coleccin de jugadas como valor.
Por otro lado, el mombre no es muy claro. No calcula aciertos, ms bien retorna las jugadas con esa cantidad de aciertos.
"
	^ self apuestasEnJuego select: [ :unaAp | (unaAp cuantosAciertosTieneEn: jugadaGanadora) = numeroDeAciertos ]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:29'!
calculaCantidadDeJugadasConAciertos: numeroDeAciertos
	^ self apuestasEnJuego select: [ :unaApuesta | (self cuantosAciertosTiene: (unaApuesta jugada) ) = numeroDeAciertos ]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:53'!
calculaGanadoresYRepartiPremios
	| primerPremio segundoPremio tercerPremio |
	
	self repartirAAgencias.
	
	primerPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion).
	segundoPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion - 1).
	tercerPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion - 2).
	
	self pagarA: primerPremio  conAciertos: (self mejorSituacion).
	self pagarA: segundoPremio  conAciertos: (self mejorSituacion - 1).
	self pagarA: tercerPremio  conAciertos: (self mejorSituacion - 2).
! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:59'!
mejorSituacion 
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:26'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:06'!
porcentajePara: unNumero
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:16'!
pozo
	^ (self apuestasEnJuego size * self valorDeJugada)
	 ! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:30'!
premioDe: unaJugada
	^ self pozo * (self porcentajePara: (self cuantosAciertosTiene: unaJugada))! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:32'!
valorDeJugada 
	self requirement! !

Trait named: #SinPosicion
	uses: {}
	category: 'Tp-TADP'!

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:12'!
cuantosAciertosTiene: unaJugada
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaSumaUno: unNumero) ]! !

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:12'!
siEstaSumaUno: unNumero
	(self ultimaJugadaGanadora includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

TestCase subclass: #TestMetaP1
	instanceVariableNames: 'miMascota mascotaDelVecino animalSalvaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-METAP-TEST'!

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 16:41'!
animalSalvaje
	^ animalSalvaje! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 16:41'!
animalSalvaje: anObject
	animalSalvaje := anObject! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
mascotaDelVecino
	^ mascotaDelVecino! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
mascotaDelVecino: anObject
	mascotaDelVecino := anObject! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
miMascota
	^ miMascota! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
miMascota: anObject
	miMascota := anObject! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 18:28'!
setUp
	Mascota compile: (('recibiDanio: unDanio <n> self  energia: energia - unDanio. ') expandMacros).
	Mascota compile: (('atacar: unObjetivo <n> self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 20]. ') expandMacros).
	Mascota compile: (('dormi: unaCantidad <n> self energia: energia + unaCantidad. ') expandMacros).
	Mascota compile: (('recibiDanio: unaCantidad de: alguien <n> self recibiDanio:( unaCantidad * alguien energia). ') expandMacros).

	Salvaje  compile: (('recibiDanio: unDanio <n> self  energia: energia - unDanio. ') expandMacros).
	Salvaje compile: (('atacar: unObjetivo <n> self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 100]. ') expandMacros).
	Salvaje compile: (('dormi: unaCantidad <n> self energia: energia + unaCantidad. ') expandMacros).
	Salvaje compile: (('recibiDanio: unaCantidad de: alguien <n> self recibiDanio:( unaCantidad * alguien energia). ') expandMacros).
	miMascota  := Mascota nuevoConEnergia: 50.
	mascotaDelVecino  := Mascota nuevoConEnergia: 50.
	animalSalvaje := Salvaje nuevoConEnergia: 50.! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:27'!
testAgregarCodigoAntesDeLosAccesorsDeUnaCategoria
	| refactor accesors |
	refactor := MethodManager new.
	refactor agregarCodigo: '" Accesor de Mascota "' antesDeLosAccesorsDe: 'Tp-TADP-Mascotas'.
	accesors := refactor obtenerAccesorsDe: (mascotaDelVecino class).
	self assert: (accesors allSatisfy: [:each | ((((mascotaDelVecino class)>>each)getSource )lineNumber: 2) sameAs:  '" Accesor de Mascota "']). ! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
testAgregarCodigoAntesDeLosAccesorsDeUnaListaDeClases
	| refactor accesors |
	refactor := MethodManager new.
	refactor agregarCodigo: '" Accesor de un Animal "' antesDeLosAccesorsDe: {Mascota. Salvaje.}. 
	accesors := refactor obtenerAccesorsDe: (mascotaDelVecino class).
	self assert: (accesors allSatisfy: [:each | ((((mascotaDelVecino class)>>each)getSource )lineNumber: 2) sameAs:  '" Accesor de un Animal "']). 
	accesors := refactor obtenerAccesorsDe: (animalSalvaje  class).
	self assert: (accesors allSatisfy: [:each | ((((animalSalvaje  class)>>each)getSource )lineNumber: 2) sameAs:  '" Accesor de un Animal "']). ! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 18:20'!
testAgregarCodigoAntesDeUnMetodoExistenteEnUnaCategoria
	MethodManager new agregarCodigo: ' " Categoria: Mascotas "' antesDeMetodosQueEmpiezanCon: 'recibiDanio:' en: 'Tp-TADP-Mascotas'. 
	self assert: ((((Mascota>>#recibiDanio:)getSource )lineNumber: 2) sameAs:  ' " Categoria: Mascotas "' ). 
	self assert: ((((Salvaje>>#recibiDanio:)getSource )lineNumber: 2) sameAs:  ' " Categoria: Mascotas "' ). 
! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:47'!
testAgregarCodigoAntesDeUnMetodoExistenteEnUnaListaDeClases
	MethodManager new agregarCodigo: ' self estado: Despierto new.' antesDeMetodosQueEmpiezanCon: 'recibiDanio:' en: {Mascota. Salvaje.}. 
	animalSalvaje estado: Dormido new.
	miMascota atacar: animalSalvaje .
	miMascota estado: Dormido new.
	animalSalvaje  atacar: miMascota.
	self assert: miMascota  estado class equals: Despierto.! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:49'!
testAgregarCodigoDespuesDeUnMetodoExistenteEnUnaCategoria
	MethodManager new agregarCodigo: ' self estado: Dormido new.' despuesDeMetodosQueEmpiezanCon: 'dormi:' en: 'Tp-TADP-Mascotas'. 
	miMascota dormi: 12.
	miMascota  atacar: mascotaDelVecino.
	self assert: mascotaDelVecino  energia equals: 50. ! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:54'!
testAgregarCodigoDespuesDeUnMetodoExistenteEnUnaListaDeClases
	MethodManager new agregarCodigo: ' self estado: Dormido new.' despuesDeMetodosQueEmpiezanCon: 'dormi:' en: {Mascota. Salvaje.}. 
	miMascota dormi: 12.
	animalSalvaje dormi: 12.
	animalSalvaje atacar: mascotaDelVecino .
	miMascota  atacar: mascotaDelVecino.
	self assert: mascotaDelVecino  energia equals: 50. ! !

TestCase subclass: #TestMetap2
	instanceVariableNames: 'grosa numero string clase1 clase2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-METAP-TEST'!

!TestMetap2 methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:33'!
setUp
	MetaUtil removeCategory: 'Tp-TADP-META2'! !

!TestMetap2 methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:28'!
testClasesQueNoCumplenConPatronProblematico

grosa := ClaseGrosa new.
numero := MiNumero new.
string := MiString new.

self assert: (grosa poseePatronProblematico: numero class ) equals: false.

self assert: (grosa poseePatronProblematico: string class ) equals: false.! !

!TestMetap2 methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:29'!
testClasesQueSiCumplenConPatronProblematico

grosa := ClaseGrosa new.
clase1 := MiClaseDePrueba new.
clase2 := MiSegundaClaseDePrueba new.

self assert: (grosa poseePatronProblematico: clase1 class) equals: true.

self assert: (grosa poseePatronProblematico: clase2 class) equals: true.! !

!TestMetap2 methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:34'!
testClasesQueSiCumplenConPatronProblematicoHaceLaMagia
	| nuevaClase |
	grosa := ClaseGrosa new.
	clase1 := MiClaseDePrueba new.
	clase2 := MiSegundaClaseDePrueba new.
	
	grosa haceElTrabajoDuroCon: clase1 class.
	grosa haceElTrabajoDuroCon: clase2 class.
	
	nuevaClase := (Smalltalk allClasses select: [:each | each name = 'MiClaseDePrueba_BIS' ]) first.
	
	self assert:  (nuevaClase asString asLowercase ) equals: 'MiClaseDePrueba_BIS'.! !

!TestMetap2 methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:33'!
testClasesQueSiCumplenConPatronProblematicoHagoLaMagiaYTienenMenosMetodos
"| metodosAntesDeLaMagia metodosDespuesDeLaMagia |
grosa := ClaseGrosa new.
clase1 := MiClaseDePrueba new.
clase2 := MiSegundaClaseDePrueba new.

metodosAntesDeLaMagia := (clase1 class selectors) size.
grosa haceElTrabajoDuroCon: clase1 class.
metodosDespuesDeLaMagia := (clase1 class selectors) size.
self assert: (metodosAntesDeLaMagia > metodosDespuesDeLaMagia) equals: true.


metodosAntesDeLaMagia := (clase2 class selectors) size.
grosa haceElTrabajoDuroCon: clase2 class.
metodosDespuesDeLaMagia := (clase2 class selectors) size.
self assert: (metodosAntesDeLaMagia > metodosDespuesDeLaMagia) equals: true."! !

TestCase subclass: #TestMetap4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-METAP-TEST'!

!TestMetap4 class methodsFor: 'history' stamp: 'MarianoGerman 9/21/2012 13:11'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testConvertirHerenciaAComp; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 47458; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2456192; instVarAt: 4 put: 151000000; yourself)); yourself)! !

!TestMetap4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 02:29'!
setUp 

Smalltalk allClasses do: [:each | 'Tp-TADP' = (each category asString) ifTrue: [each removeFromSystem]].

MetaUtil recreateCategory: 'backUp'. self ! !

!TestMetap4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:56'!
testConversion

|superClaseLoto nuevaSuperClase juego loto claseJuego claseLoto |

claseJuego := (Smalltalk allClasses select: [:each | ('Tp-TADP' = (each category asString)).(each name = 'Juego')]) first.
claseLoto := (Smalltalk allClasses select: [:each | ('Tp-TADP' = (each category asString)).(each name = 'Loto')]) first.

juego:= claseJuego new.
loto:= claseLoto new.

ConvHerenciaAComp converti: juego.

superClaseLoto := loto class superclass asString .
nuevaSuperClase := (juego instVarNamed: 'estiloDeJuego') class asString.

self assert: (superClaseLoto sameAs: nuevaSuperClase).
! !

TestCase subclass: #TestsGenerales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

TestCase subclass: #TestsLoto
	instanceVariableNames: 'apuestaLoto agenciaTota juegoLoto jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:23'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	juegoLoto sorteame: #(5 6 7 8).
	
	self assert: agenciaTota caja equals: (2 * 0.12).! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:16'!
testCuantoGanaAgencia

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: agenciaTota caja equals: 0.28.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:03'!
testCuantoGanaUnaApuesta
	
	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: (juegoLoto premioDe: jugada) equals: 2*0.4.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:31'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	self assert: (juegoLoto apuestasEnJuego size > 0).
	! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:08'!
testPozo

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: #(8).
	
	self assert: (juegoLoto pozo) equals:  2.! !

TestCase subclass: #TestsPagaOPaga
	instanceVariableNames: 'agenciaTota juegoPagaLPM jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:42'!
testCuantoGanaAgencia

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoPagaLPM sorteame: jugada.
	
	self assert: agenciaTota caja equals: (337.5 * 0.1).! !

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:42'!
testCuantoGanaUnaApuesta 

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoPagaLPM sorteame: jugada.
	
	self assert: (juegoPagaLPM premioDe: jugada conMonto: 100 ) equals: (337.5 * 0.7).! !

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:34'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	self assert: juegoPagaLPM apuestasEnJuego size > 0.! !

TestCase subclass: #TestsProde
	instanceVariableNames: 'agenciaGanaRiver juegoProde jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:38'!
testAgenciaGanaFijoPorJugada 

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: #(e e e e e e e e e e e e e).
	
	self assert: agenciaGanaRiver caja equals: (5*0.15) ! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:16'!
testCuantoGanaAgencia
	
	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: jugada.
	
	self assert: agenciaGanaRiver caja equals: ((5 * 0.15) + (5 * 0.5 * 0.05))! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:14'!
testCuantoGanaUnaApuesta 

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: jugada.
	
	self assert: (juegoProde premioDe: jugada) equals: (5 * 0.5)! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:37'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaGanaRiver  := Agencia new.
	juegoProde  := Prode new.
	jugada := OrderedCollection new.

	jugada addAll: #(l l l l l l e e e e e v v).

	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	self assert: (juegoProde apuestasEnJuego size > 0).
	! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 20:07'!
testPozo

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(1).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	self assert: juegoProde pozo equals: 5.! !

TestCase subclass: #TestsQuini
	instanceVariableNames: 'agenciaTota juegoQuini jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:41'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #().
	
	self assert: agenciaTota caja equals: (100 * 0.17)! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:41'!
testCuantoGanaAgencia 

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #(0000 1412 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333).
	
	self assert: agenciaTota caja equals: 100 * 0.17.! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:42'!
testCuantoGanaUnaApuesta 

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.
		
	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #(0000 1412 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333).
	
	self assert: (juegoQuini premioDe: jugada conMonto: 100) equals: 3500 * 100.! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:42'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	self assert: (juegoQuini apuestasEnJuego size > 0).
	! !

Object subclass: #Agencia
	instanceVariableNames: 'caja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:57'!
aPagar
	^ aPagar! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:04'!
aPagar: anObject
	aPagar add: anObject.! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:23'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:33'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:34'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:42'!
initialize
	self caja: 0! !

!Agencia methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 15:53'!
pagaALosGanadores
"
1-
Si no hay ms timberos / jugadores => volar este mtodo.
"
	self aPagar do: [:unaTupla | (unaTupla second) ganaste: (unaTupla first ) ]! !

!Agencia methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 15:52'!
pagale:jugador elMonto:pago
"
1-
Volarlo porque no es necesario.
"
	| coleccionPago |
	coleccionPago := Array newFrom:(1 to: 2).
	coleccionPago at: 1 put: pago.
	coleccionPago at: 2 put: jugador.
	self aPagar: coleccionPago.
	
! !

Object subclass: #Apuesta
	instanceVariableNames: 'jugada agencia monto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia
	^ agencia.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia: unaAgencia
	agencia := unaAgencia.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/8/2012 05:40'!
coincidisCon: jugadaGanadora  enPos: unaPosicion 
	((jugadaGanadora at: unaPosicion) = (self jugada at: unaPosicion)) ifTrue: [^1] ifFalse: [^0].! !

!Apuesta methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 17:21'!
cuantosAciertosTieneConPosicion: jugadaGanadora
"
1-
Solo tiene sentido para apuestas de juegos con aciertos y posicin.

3-
Creo que es ms facil comparar dos listas de la misma logitud avanzando elemento por elemento, comparando si son iguales.

4-
Hay una cosa piola que es
1 to: 13 do:
para evitar la lista harcodeada
"
	^ self  listaHarcodeada inject: 0 into: [:acum :unaPosicion | acum + (self coincidisCon: jugadaGanadora enPos: unaPosicion)] ! !

!Apuesta methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 17:28'!
cuantosAciertosTieneEn: jugadaGanadora
"
1-
Solo para juegos con aciertos.
"
	^ self jugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaEn: jugadaGanadora sumaUno: unNumero) ]! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 21:18'!
dameNumeroADividir: cantidadCifras
	cantidadCifras = 1 ifTrue: [^10].
		cantidadCifras = 2 ifTrue: [^100].
			cantidadCifras = 3 ifTrue: [^1000].
				cantidadCifras = 4 ifTrue: [^10000].! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego
	^ juego! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego: anObject
	juego := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
jugada 
	^jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:34'!
jugada: unaJugada 
	jugada := unaJugada.! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador
	^ jugador! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador: anObject
	jugador := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 17:09'!
listaHarcodeada 
"
3-
Realmente es necesaria esta lista?
"
	^ #(1 2 3 4 5 6 7 8 9 10 11 12 13)! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto 
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto: unMonto
	monto := unMonto! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 18:00'!
posicion
	^ posicion! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 18:00'!
posicion: anObject
	posicion := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 17:04'!
siEstaEn: unaJugada sumaUno: unNumero
"
1-
No depende de la apuesta, porque est ac?
"
	(unaJugada includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

!Apuesta methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 16:11'!
sosGanadoraQuini: jugadaGanadora 
"
1-
Una apuesta no solo es para quini, esto me complica la apuesta y no me deja expandir el diseo al resto de los juegos claramente.

1-
Estn seguros de que

jugadaGanadora asOrderedCollection

no les cambia el orden de los resultados? (yo hara un test para estar seguro)
"
	| numeroGanadorEnPosicion cantidadCifras |
	numeroGanadorEnPosicion :=  jugadaGanadora asOrderedCollection at: self posicion.
	
	cantidadCifras := self jugada size.
	
	^(( numeroGanadorEnPosicion \\ (self dameNumeroADividir: cantidadCifras)) = ((self jugada) asNumber) ).
	
! !

Object subclass: #ClaseGrosa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'!

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:13'!
agregarAtributo: unAtributo para: unaClase
	unaClase addInstVarNamed: unAtributo.
	
	unaClase compile: unAtributo asString , ' 
	^', unAtributo asString , '.'.
	
	unaClase compile: unAtributo asString, ': unObject
	' , unAtributo asString , ':= unObject.'.


! !

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:13'!
borrarAtributo: unAtributo para: unaClase 
	| setterYGetter |
	unaClase removeInstVarNamed: unAtributo.
	
	setterYGetter := unaClase selectors select: [:unSelector | (unSelector asString = unAtributo) |  (unSelector asString = (unAtributo, ':') )].
	
	setterYGetter do: [:unSelector | unaClase removeSelector: unSelector ].! !

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:13'!
borrarMetodos: coleccionDeMetodos para: unaClase

	coleccionDeMetodos do: [:unMetodo | unaClase removeSelector: unMetodo].
	! !

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:13'!
crearNuevaClase: nombreClase con: unAtributo yCon: coleccionDeMetodos porMedioDe: unaClase 

	| clase claseNueva |
	clase := nombreClase capitalized.
	
Object subclass: (clase asSymbol)
	instanceVariableNames: '' 
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'.
	
	claseNueva := (Smalltalk allClasses select: [:each | each name = clase ]) first.
	
	self agregarAtributo: unAtributo para: claseNueva.
	
	coleccionDeMetodos do:[:unMetodo | claseNueva compile: ((unaClase >>unMetodo) getSource) ].
	^claseNueva.
	
	
	
	"mensaje := self dameNombreMensaje: 'agregarAtributo:'.
	codigo:= (self class>> mensaje) getSource.
	
	self celular compile: codigo."
	
	"listaDeAtributos do: [:unAtributo | self celular agregarAtributo: (unAtributo asString)]."
	
	
	 ! !

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:14'!
dameMensajesQueHacenAlgo: unaClase
	| auxSetAndGet coleccionFinal|
	auxSetAndGet := OrderedCollection new.
	(unaClase instVarNames) do: [:inst | auxSetAndGet  add: (inst, ':')].
	auxSetAndGet  add: 'initialize'.

	coleccionFinal := unaClase selectors difference: (unaClase instVarNames).
	
	^coleccionFinal reject: [:unSelector | (auxSetAndGet includes: unSelector)].! !

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:14'!
haceElTrabajoDuroCon: unaClase
	
	| coleccion1 coleccion2 primero segundo nuevaClase |
	coleccion1 := OrderedCollection new.
	coleccion2 := OrderedCollection new.
	
	primero := unaClase instVarNames first.
	segundo := unaClase instVarNames last.
	
	"Primer subconjunto"
	coleccion1 := (self dameMensajesQueHacenAlgo: unaClase) select: [:unMsj | (unaClase>>unMsj) usesInstVarNamed: primero].
	
	"Segundo Subconjunto"
	coleccion2 := (self dameMensajesQueHacenAlgo: unaClase) select: [:unMsj | (unaClase>>unMsj) usesInstVarNamed: segundo].
	
	"Creo una nueva clase con los metodos del subconjunto 2 y el atributo que usan"
	nuevaClase := self crearNuevaClase: (unaClase asString , '_BIS') con: segundo yCon: coleccion2 porMedioDe: unaClase.

	"Borra los metodos asociados con el atributo que pase"
	self borrarMetodos: coleccion2 para: unaClase.
	
	"Borro el atributo que paso a la nueva clase"
	self borrarAtributo: segundo para: unaClase.
	
	"Agrego un atributo que referencie a la nueva clase"
	self agregarAtributo: (nuevaClase asString) asLowercase para: unaClase.

! !

!ClaseGrosa methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/24/2012 16:14'!
poseePatronProblematico: unaClase
		
	(unaClase instVarNames size > 2) ifTrue: [^false].
		
	((self dameMensajesQueHacenAlgo: unaClase) allSatisfy:  [:unMensaje | (unaClase  instVarNames allSatisfy: [:unAccesor | (unaClase >> unMensaje) usesInstVarNamed: unAccesor])])
	ifTrue: [^false]
	ifFalse: [^true].! !

Object subclass: #ConvHerenciaAComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META4'!

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 04:35'!
cambiaPadreDe: unPadre aOtro: nuevoPadre

		unPadre class allSubclasses do: [:unaSubClase | unaSubClase superclass: nuevoPadre class].! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:52'!
converti: unPadre

	| estiloDeJuego stringClaseNueva claseNueva nuevoPadre metodosAcambiar |
	
	estiloDeJuego := self crearVarInst: unPadre.
	
	stringClaseNueva := self crearNuevaClase.
	claseNueva := (Smalltalk allClasses select: [:each | each name = stringClaseNueva]) first.
	
	nuevoPadre := claseNueva new.
	
	unPadre instVarNamed: estiloDeJuego put: nuevoPadre.

	self seleccionarMetodosDe: unPadre yPasarselosA: nuevoPadre conVariableDeInstancia: estiloDeJuego.

	self cambiaPadreDe: unPadre aOtro: nuevoPadre.

! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:10'!
copiaMetodo: unMetodo a: nuevoPadre
       
	nuevoPadre class compile: unMetodo.! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 03:31'!
crearNuevaClase
  
          | nombreClase |
	     nombreClase := 'JuegoType'.

	    Object subclass: (nombreClase asSymbol)    
	    instanceVariableNames: ''
	    classVariableNames: ''
    	    poolDictionaries: ''
	    category:  'Tp-TADP'.
	 
	   ^nombreClase.! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 02:49'!
crearVarInst: unPadre

	| instancia |
	instancia := 'estiloDeJuego'.
	unPadre class addInstVarNamed: instancia.
	
	^instancia! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:01'!
esIgual: unMetodo a: unMetodoPapa 

	^(unMetodo asString sameAs: unMetodoPapa asString) ! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:04'!
estaRepetido: unMetodoPapa EnLosMetodosDeSusHijos: unPadre

	| subClases result |
	subClases :=  unPadre class subclasses.

	result:= subClases anySatisfy: [:unaSubClase | self seRepiteElMetodo: unMetodoPapa enLaClase: unaSubClase].

	^result.! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:50'!
modificaMetodo: unMetodo delPadre: unPadre con: nuevoPadre yVariable: estiloDeJuego

		| variableInstancia |
		
		variableInstancia := unPadre instVarNamed: estiloDeJuego.
		
		unPadre class compile: (((unMetodo asString),' <n>',estiloDeJuego,' ',(unMetodo asString),'.') expandMacros).
! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:22'!
mover: unMetodo desde: unPadre a: nuevoPadre deVariable: estiloDeJuego

	self copiaMetodo: ((unPadre class >> unMetodo) getSource) a: nuevoPadre.
	self modificaMetodo: unMetodo delPadre: unPadre con: nuevoPadre yVariable: estiloDeJuego.! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:01'!
seRepiteElMetodo: unMetodoPapa enLaClase: unaSubClase

	| resultado |
	resultado := unaSubClase selectors anySatisfy: [:unMetodo | self esIgual: unMetodo a: unMetodoPapa]. 
	
	^resultado! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:21'!
seleccionarMetodosDe: unPadre yPasarselosA: nuevoPadre conVariableDeInstancia: estiloDeJuego

	| coleccionDeMetodos |
.	coleccionDeMetodos := Set new.
	
	coleccionDeMetodos := unPadre class selectors select: [:unMetodoPapa | self estaRepetido: unMetodoPapa EnLosMetodosDeSusHijos: unPadre ].

	coleccionDeMetodos do: [:unMetodo | (self mover: unMetodo desde: unPadre a: nuevoPadre deVariable: estiloDeJuego)].! !

Object subclass: #Estado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

Estado subclass: #Despierto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Despierto methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 09:46'!
puedeAtacar
	^true.! !

Estado subclass: #Dormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Dormido methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/16/2012 15:42'!
puedeAtacar
	^false.! !

Object subclass: #GeneradorDeCodigo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/20/2012 22:59'!
obtenerCabeceraDe: unMensaje en: unaClase

	^((unaClase  >>unMensaje ) getSource ) lineNumber: 1. ! !

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/20/2012 23:16'!
obtenerCodigoDe: unMetodo en: unaClase 
	^ (unaClase >> unMetodo) getSource.! !

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:04'!
obtenerLinea: unaLinea De: unMensaje en: unaClase

	^((unaClase  >>unMensaje ) getSource ) lineNumber: unaLinea. ! !

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:52'!
obtenerStatementsDe: unMensaje en: unaClase
	|statements arrayDeLineas|
	"metodo := ''.
	2 to: ((unaClase >> unMensaje) getSource ) lineCount  do:[:each | metodo := metodo ,(((unaClase>> unMensaje ) getSource ) lineNumber: each ) ]."
	arrayDeLineas := ((unaClase  >> unMensaje) getSource )lines.
	arrayDeLineas at:1 put: ''.
	statements := arrayDeLineas inject: '' into:[:metodo :each| metodo,'<n>',each].
	^(statements expandMacros ) trimLeft .! !

GeneradorDeCodigo subclass: #PosteriorAlExistente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!PosteriorAlExistente methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 02:28'!
agregarCodigo: codigo alMetodo: unMetodo enLaClase: unaClase 
	|nuevoMensaje clausulaReturn posicionReturn|
	nuevoMensaje := (self obtenerCodigoDe: unMetodo  en: unaClase).
	posicionReturn := nuevoMensaje findString: '^' .
	clausulaReturn := ''.
	(posicionReturn > 0) ifTrue: [clausulaReturn := nuevoMensaje copyFrom:  posicionReturn   to:  nuevoMensaje size.
								  nuevoMensaje := nuevoMensaje copyFrom:  1 to:(posicionReturn-1)].
	nuevoMensaje :=  nuevoMensaje ,'<n>', codigo,'<n>',clausulaReturn.
	unaClase compile:( nuevoMensaje expandMacros).! !

GeneradorDeCodigo subclass: #PrevioAlExistente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!PrevioAlExistente methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:27'!
agregarCodigo: codigo alMetodo: unMetodo enLaClase: unaClase 
	|cabecera statements nuevoMensaje|
	cabecera := self obtenerCabeceraDe: unMetodo  en: unaClase. 
	statements := self obtenerStatementsDe: unMetodo  en: unaClase.
	nuevoMensaje := cabecera,'<n>', codigo ,'<n>', statements .
	unaClase compile: (nuevoMensaje expandMacros).! !

Object subclass: #Hola
	instanceVariableNames: 'hola2 hola3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'!

!Hola methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
hola2
	^ hola2! !

!Hola methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
hola2: anObject
	hola2 := anObject! !

!Hola methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
hola3
	^ hola3! !

!Hola methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
hola3: anObject
	hola3 := anObject! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego ultimaJugadaGanadora estiloDeJuego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:42'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 19:30'!
apuesto: unaJugada en: unaAgencia conMonto: unNumero
		| unaApuesta |
	unaApuesta := Apuesta new.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unNumero.
	
	self apuestasEnJuego add: unaApuesta.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:57'!
calculaGanadoresYRepartiPremios 
	estiloDeJuego calculaGanadoresYRepartiPremios.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:57'!
initialize 
estiloDeJuego initialize.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
recibiApuesta: apuesta
	self apuestasEnJuego add: apuesta! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:40'!
repartirAAgencias
	apuestasEnJuego do: [ :unaApuesta | unaApuesta agencia ganaste: (unaApuesta monto * self PorcentajeFijoPorJugada) ]! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:49'!
sorteame: unaJugada
	self ultimaJugadaGanadora: unaJugada.
	self calculaGanadoresYRepartiPremios.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:48'!
ultimaJugadaGanadora
	^ ultimaJugadaGanadora.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:57'!
ultimaJugadaGanadora: jugadaGanadora
	 ultimaJugadaGanadora := jugadaGanadora.! !

Object subclass: #JuegoType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!JuegoType methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:57'!
calculaGanadoresYRepartiPremios
	self subclassResponsibility ! !

!JuegoType methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/23/2012 17:57'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

JuegoType subclass: #Loto
	uses: Poceado + SinPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgenciaGanadora'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Loto class
	uses: Poceado classTrait + SinPosicion classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:37'!
PorcentajeFijoPorJugada
	^ 0.12! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Loto methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 16:41'!
calculaGanadoresYRepartiPremio: jugadaGanadora 
     | seisAsiertos cincoAsiertos cuatroAsiertos  |
"
1-
Hace lo mismo que le Prode. Ver como separar este comportamiento para no repetir.
"
	self actualizarPozo.	
	self repartirAAgencias.
	
	seisAsiertos := self calculaAciertos: 6 paraJugada: jugadaGanadora.	
	cincoAsiertos := self calculaAciertos: 5 paraJugada: jugadaGanadora.	
	cuatroAsiertos := self calculaAciertos: 4 paraJugada: jugadaGanadora.
	
	self pagarA: seisAsiertos conAciertos: 6.
	self pagarA: cincoAsiertos conAciertos: 5.
	self pagarA: cuatroAsiertos conAciertos: 4.



! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:10'!
cuantosAciertosTiene: unaJugada
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaSumaUno: unNumero) ]! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 
	super initialize.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:43'!
mejorSituacion 
	^ 6! !

!Loto methodsFor: 'accessing' stamp: 'BrunoFischetti 9/14/2012 00:07'!
porcentajePara: unNumero
	unNumero == 6 ifTrue: [^0.4].
	unNumero == 5 ifTrue: [^0.17].
	unNumero == 4 ifTrue: [^0.05].! !

!Loto methodsFor: 'accessing' stamp: 'pdanibenitez 9/8/2012 03:50'!
pozo
	^ pozo! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo: anObject
	pozo := anObject! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:57'!
valorDeJugada 
	^ 2.! !

JuegoType subclass: #PagaOPaga
	uses: SinPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeAgenciaGanadora PorcentajeJugadorGanador'
	poolDictionaries: ''
	category: 'Tp-TADP'!

PagaOPaga class
	uses: SinPosicion classTrait
	instanceVariableNames: ''!

!PagaOPaga class methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 15:51'!
porcentajeParaAgencia
"
3-
Esos est sin uso, no?
"
	^ PorcentajeParaAgencia! !

!PagaOPaga class methodsFor: 'accessing' stamp: 'PabloRomanelli 9/8/2012 15:51'!
porcentajeParaAgencia: anObject
"
3-
Esos est sin uso, no?
"
	PorcentajeParaAgencia := anObject! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:29'!
PorcentajeAgenciaGanadora
	^ 0.1! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:39'!
PorcentajeJugadorGanador
	^ 0.7! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 23:59'!
PorcentajeParaAgencia
	^ 0.1! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 23:59'!
PorcentajeParaJugador 
	^ 0.7! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/8/2012 00:05'!
calculaGanadoresYRepartiPremio: jugadaGanadora 
	self apuestasEnJuego do: [:apuesta | self pagaleA: apuesta conJugada: jugadaGanadora ]! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:45'!
calculaGanadoresYRepartiPremios
	self apuestasEnJuego
		do: [ :unaApuesta | 
			unaApuesta agencia
				ganaste: ((self premioDe: unaApuesta jugada conMonto: unaApuesta monto) * self PorcentajeAgenciaGanadora) / self PorcentajeJugadorGanador ]! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 17:52'!
pagaleA: unaApuesta conJugada: jugadaGanadora
"
1-
Solo depende de la apuesta, no debera estar ac.

1-
Sacar la repeticin de cdigo.
"
	unaApuesta jugador
		ganaste:
			(((unaApuesta cuantosAciertosTieneEn: jugadaGanadora) / 10) raisedTo: 3) * unaApuesta monto * self PorcentajeParaJugador.
	unaApuesta agencia
		ganaste:
			(((unaApuesta cuantosAciertosTieneEn: jugadaGanadora) / 10) raisedTo: 3) * unaApuesta monto * self PorcentajeParaAgencia.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:39'!
premioDe: unaJugada conMonto: unMonto
	^ ((self cuantosAciertosTiene: unaJugada) / 10 raisedTo: 3) * unMonto * self PorcentajeJugadorGanador! !

JuegoType subclass: #Prode
	uses: Poceado + ConPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgenciaGanadora'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Prode class
	uses: Poceado classTrait + ConPosicion classTrait
	instanceVariableNames: ''!

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 19:32'!
PorcentajeFijoPorJugada
	^ 0.15! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:54'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/8/2012 05:35'!
calculaAciertos: numeroDeAciertos paraJugada: jugadaGanadora
	^ self apuestasEnJuego select: [ :unaAp | (unaAp cuantosAciertosTieneConPosicion: jugadaGanadora) = numeroDeAciertos ]! !

!Prode methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 16:42'!
calculaGanadoresYRepartiPremio: jugadaGanadora
"
1-
Hace lo mismo que le Loto. Ver como separar este comportamiento para no repetir.
"
	| primerPremio segundoPremio tercerPremio |
	self actualizarPozo.
	self repartirAAgencias.
	
	primerPremio := self calculaAciertos: 13 paraJugada: jugadaGanadora.
	segundoPremio := self calculaAciertos: 12 paraJugada: jugadaGanadora.
	tercerPremio := self calculaAciertos: 11 paraJugada: jugadaGanadora.
	
	self pagarA: primerPremio  conAciertos: 13.
	self pagarA: segundoPremio  conAciertos: 12.
	self pagarA: tercerPremio  conAciertos: 11.
! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
mejorSituacion 
	^ 13! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:25'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	
	self mejorSituacion = numeroDeAciertos ifTrue: [
	
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]
			
		]! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
porcentajePara: unNumero
	unNumero == 13 ifTrue: [^0.5].
	unNumero == 12 ifTrue: [^0.35].
	unNumero == 11 ifTrue: [^0.11].! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:25'!
posiciones 
	^ #(1 2 3 4 5 6 7 8 9 10 11 12 13)! !

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:19'!
pozo
	^ pozo! !

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:18'!
pozo: anObject
	pozo := anObject.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:51'!
valorDeJugada 
	^ 5! !

JuegoType subclass: #Quiniela
	uses: ConPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Quiniela class
	uses: ConPosicion classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:42'!
PorcentajeFijoPorJugada
	^ 0.17! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:06'!
acertoCon: unaJugada
	^ self coincide: (unaJugada first) con: ((self ultimaJugadaGanadora at: unaJugada second) \\ (self porCuantoSeTieneQueDividir: unaJugada first))! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 17:37'!
calculaGanadoresYRepartiPremio: jugadaGanadora
"
1-
Solo depende de la apuesta.
"
	| coleccionDeGanadores |
	
	self repartirAAgencias.
	
	coleccionDeGanadores := apuestasEnJuego select: [ :ap | ap sosGanadoraQuini: jugadaGanadora ].
	coleccionDeGanadores do: [ :apuestaG | apuestaG agencia pagale: apuestaG jugador elMonto: (self correspondePagar: apuestaG) ]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:33'!
calculaGanadoresYRepartiPremios
	
	self repartirAAgencias.
	! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:49'!
cantidadCifrasPara: unNumero
	(unNumero / 1000) >= 1 ifTrue: [^4].
	(unNumero / 100) >= 1 ifTrue: [^3].
	(unNumero / 10) >= 1 ifTrue: [^2].
	^1.
	! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'PabloRomanelli 9/8/2012 17:43'!
correspondePagar: apuestaG
	| tipoDeGanancia |
"
1-
Solo depende de la apuesta.

4-
Algo cmodo para formatear el cdigo (identar y esas cosas) es usar ctrl+r.
"
	
	apuestaG jugada size = 1
		ifTrue: [ tipoDeGanancia := 7 ].
	apuestaG jugada size = 2
		ifTrue: [ tipoDeGanancia := 70 ].
	apuestaG jugada size = 3
		ifTrue: [ tipoDeGanancia := 500 ].
	apuestaG jugada size = 4
		ifTrue: [ tipoDeGanancia := 3500 ].

	^ apuestaG monto * tipoDeGanancia.! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:44'!
multiplicadorCorrespondienteParaCifrasDe: unaJugada
	| numero |
	numero := self cantidadCifrasPara: (unaJugada first).
	
	numero = 4 ifTrue: [^3500].
	numero = 3 ifTrue: [^500].
	numero = 2 ifTrue: [^70].
	numero = 1 ifTrue: [^7]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:06'!
porCuantoSeTieneQueDividir: unNumero
	| numero |
	numero := self cantidadCifrasPara: unNumero. 
	
	numero = 4 ifTrue: [^10000].
	numero = 3 ifTrue: [^1000].
	numero = 2 ifTrue: [^100].
	numero = 1 ifTrue: [^10]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:37'!
premioDe: unaJugada conMonto: unMonto
	^ (self multiplicadorCorrespondienteParaCifrasDe: unaJugada) * (unMonto) * ( self acertoCon: unaJugada)! !

Object subclass: #Mascota
	instanceVariableNames: 'energia estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Mascota class methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:09'!
nuevoConEnergia: unaEnergia 
	|unaMascota|
	unaMascota := self new.
	unaMascota energia: unaEnergia.
	unaMascota estado: Despierto new.
	^unaMascota.! !

!Mascota class methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 10:30'!
saluda
	^'hola bruno'.! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/22/2012 13:56'!
_recibiDanio: unDanio 
 self  energia: energia - unDanio. 
"un Comentarioo "

"un Comentarioo 2 "
^energia.
! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
atacar: unObjetivo 
 self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 20]. ! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
dormi: unaCantidad 
 self energia: energia + unaCantidad. 
 self estado: Dormido new.
! !

!Mascota methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
energia
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
^ energia! !

!Mascota methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
energia: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
energia := anObject. ! !

!Mascota methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
estado
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
^ estado! !

!Mascota methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
estado: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
estado := anObject.! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 09:32'!
prueba: unaPrueba  

! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
recibiDanio: unDanio 
 self  energia: energia - unDanio. ! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
recibiDanio: unaCantidad de: alguien 
 self recibiDanio:( unaCantidad * alguien energia). ! !

Object subclass: #MethodManager
	instanceVariableNames: 'generador estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:26'!
agregarCodigo: codigo aLosAccesorsDe: unaClase
	|listaDeAccesors|
	listaDeAccesors := self obtenerAccesorsDe: unaClase.
	listaDeAccesors do:[:each | self generador agregarCodigo: codigo alMetodo: each  enLaClase: unaClase ].
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:09'!
agregarCodigo: codigo aLosMensajesQueComienzanCon: unaCadena enLaClase: unaClase
	|listaDeMensajes|
	listaDeMensajes := unaClase selectors select:[:each | each asString  beginsWith:  unaCadena]. 
	listaDeMensajes do:[:each | self generador agregarCodigo: codigo alMetodo: each  enLaClase: unaClase ].
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:25'!
agregarCodigo: codigo aLosMetodosQueEmpiezanCon: unaCadena en: clases
	|listaDeClases|
	"Si es un string entonces es una categoria y debo buscar todos sus metodos"
	listaDeClases := self listarClases: clases.
	listaDeClases do: [: each | (self estrategia) value: codigo value: unaCadena value: each ].
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo antesDeLosAccesorsDe: clases
	self generador: PrevioAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosAccesorsDe: cla]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: '' en: clases.
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo antesDeMetodosQueEmpiezanCon: unaCadena en: clases
	self generador: PrevioAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosMensajesQueComienzanCon: cad enLaClase: cla ]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: unaCadena  en: clases.
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo despuesDeLosAccesorsDe: clases
	self generador: PosteriorAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosAccesorsDe: cla]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: '' en: clases.
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo despuesDeMetodosQueEmpiezanCon: unaCadena en: clases
	self generador: PosteriorAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosMensajesQueComienzanCon: cad enLaClase: cla ]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: unaCadena  en: clases.
! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 01:15'!
estrategia
^ estrategia! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 01:14'!
estrategia: anObject
estrategia := anObject! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 01:28'!
generador
^ generador! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/20/2012 22:50'!
generador: anObject
	generador := anObject! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 10:35'!
listarClases: clases
	|listaDeClases|
	clases isString ifTrue:[ listaDeClases  := (SystemOrganization listAtCategoryNamed: clases)collect: [:each | Smalltalk globals at: each]]
					ifFalse:[listaDeClases := clases].
	^listaDeClases.! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:26'!
obtenerAccesorsDe: unaClase
	^unaClase selectors select:[:selector | unaClase instVarNames anySatisfy: [:instVar|(selector asString sameAs: instVar) | (selector asString sameAs: (instVar,':'))]].
	! !

Object subclass: #MiClaseDePrueba
	instanceVariableNames: 'atributo1 atributo2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'!

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
atributo1
	^ atributo1! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
atributo1: anObject
	atributo1 := anObject! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
atributo2
	^ atributo2! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:15'!
atributo2: anObject
	atributo2 := anObject! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
metodoA
	^atributo1 + 10! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
metodoB
	^atributo1 * 2! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
metodoC
	^atributo2 * 10! !

!MiClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
metodoD
	^atributo2 - 7! !

Object subclass: #MiNumero
	instanceVariableNames: 'primero segundo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'!

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
dameDivision
	^ (primero + segundo).! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
dameMultiplicacion
	^ (primero + segundo).! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
dameResta
	^ (primero + segundo).! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
dameSuma
	^ (primero + segundo).! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
primero
	^ primero! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
primero: anObject
	primero := anObject! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
segundo
	^ segundo! !

!MiNumero methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:16'!
segundo: anObject
	segundo := anObject! !

Object subclass: #MiSegundaClaseDePrueba
	instanceVariableNames: 'primerAtributo segundoAtributo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'!

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:18'!
cuartoMetodo
	^ segundoAtributo - 90 * 1! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
primerAtributo
	^ primerAtributo! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
primerAtributo: anObject
	primerAtributo := anObject! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:18'!
primerMetodo
	^ primerAtributo *100! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
segundoAtributo
	^ segundoAtributo! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:17'!
segundoAtributo: anObject
	segundoAtributo := anObject! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:18'!
segundoMetodo
	^ primerAtributo + 30! !

!MiSegundaClaseDePrueba methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:18'!
tercerMetodo
	^ segundoAtributo - 100! !

Object subclass: #MiString
	instanceVariableNames: 'primerString segundoString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META2'!

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
dameConcatenacion
	^primerString , segundoString.! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
dameConcatenacionInversa
	^segundoString , primerString.! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
dameRepeticion
	^primerString , primerString ,segundoString , segundoString.! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
dameRepeticionInversa
	^segundoString , segundoString , primerString , primerString.! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
primerString
	^ primerString! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
primerString: anObject
	primerString := anObject! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
segundoString
	^ segundoString! !

!MiString methodsFor: 'accessing' stamp: 'pdanibenitez 9/24/2012 16:19'!
segundoString: anObject
	segundoString := anObject! !

Object subclass: #Salvaje
	instanceVariableNames: 'energia estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Salvaje class methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:32'!
nuevoConEnergia: unaEnergia 
	|unSalvaje|
	unSalvaje := self new.
	unSalvaje energia: unaEnergia.
	unSalvaje estado: Despierto new.
	^unSalvaje .! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
atacar: unObjetivo 
 self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 100]. ! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
dormi: unaCantidad 
 self energia: energia + unaCantidad. 
 self estado: Dormido new.
! !

!Salvaje methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
energia
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
^ energia! !

!Salvaje methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
energia: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
energia := anObject! !

!Salvaje methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
estado
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
^ estado! !

!Salvaje methodsFor: 'accessing' stamp: 'pdanibenitez 9/22/2012 23:20'!
estado: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de un Animal "
" Accesor de Mascota "
estado := anObject! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
recibiDanio: unDanio 
 self  energia: energia - unDanio. ! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/22/2012 23:20'!
recibiDanio: unaCantidad de: alguien 
 self recibiDanio:( unaCantidad * alguien energia). ! !
